#include "inf_br.h"

void mpq_out_stream(FILE *stream, mpq_t op)
{
  mpq_out_str(stream,10,op);
}

void mpq_init_set(mpq_ptr rop,mpq_srcptr op)
{
  mpq_init(rop);
  mpq_set(rop,op);
}

#include"mpai.c"


void inf_br_init(inf_br_ref a)
{
  mpai_init(a);
}

void inf_br_init_i(inf_br_ref a,const RS_LONG b)
{
  mpai_init(a);
  mpai_set_si(a,b);
}

void inf_br_init_str(inf_br_ref a,const RS_STRING b)
{
  rs_undef_void("inf_br_init_str");
  /*  mpai_init(a);
  mpz_set_str(mpai_numref(a),b,10);
  mpz_set_str(mpai_denref(a),b,10);*/
}

void inf_br_init_c(inf_br_ref a,inf_br_const b)
{
  mpai_init(a);
  mpai_set(a,b);
}

void inf_br_set_i(inf_br_ref a,const RS_LONG b)
{
  mpai_set_si(a,b);
}

void inf_br_set_c(inf_br_ref a,inf_br_const b)
{
  mpai_set(a,b);
}

RS_BOOL  inf_br_isNull(inf_br_const a)
{
  return(mpai_isNull(a));
  /*
  return(RS_EQ(mpai_cmp_ui(a,0),0));
  */
}

RS_BOOL  inf_br_isPos(inf_br_const a)
{
  return(RS_GEQ(mpai_cmp_ui(a,0),0));
}

RS_BOOL  inf_br_isNeg(inf_br_const a)
{
  return(RS_LEQ(mpai_cmp_ui(a,0),0));
}

RS_BOOL  inf_br_isUnit(inf_br_const a)
{
  return(RS_EQ(mpai_cmp_ui(a,1),0));
}

RS_BOOL  inf_br_isEq(inf_br_const a,inf_br_const b)
{
  return(RS_EQ(mpai_cmp(a,b),0));  
}  

RS_I16   inf_br_cmp(inf_br_const a,inf_br_const b)
{
  return(mpai_cmp(a,b));  
}

RS_I16   inf_br_cmp_i(inf_br_const a,const RS_LONG b)
{
  if(RS_GEQ(b,0))
    return(mpai_cmp_ui(a,b));
  else
    return(-mpai_cmp_ui(a,b));
}

RS_I16   inf_br_sign(inf_br_const a)
{
  return(mpai_cmp_ui(a,0));  
}

void     inf_br_add(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_add(a,b,c);  
}

void     inf_br_sub(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_sub(a,b,c);  
}

void     inf_br_mul(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_mul(a,b,c);  
}

void     inf_br_div(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_div(a,b,c);  
}

void     inf_br_exactdiv(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_div(a,b,c);  
}

void     inf_br_addmul(inf_br_ref a,inf_br_const b,inf_br_const c,inf_br_const d)
{
  mpai_mul(a,c,d);
  mpai_add(a,a,b);
}

void     inf_br_submul(inf_br_ref a,inf_br_const b,inf_br_const c,inf_br_const d)
{
  mpai_mul(a,c,d);
  mpai_sub(a,b,a);    
}

void     inf_br_comb(inf_br_ref a,inf_br_const b,inf_br_const c,inf_br_const d,inf_br_const e)
{
  mpai_t tmp;
  mpai_init(tmp);
  mpai_mul(tmp,d,e);
  mpai_mul(a,b,c);
  mpai_add(a,a,tmp);
}

void     inf_br_neg(inf_br_ref a,inf_br_const b)
{
  mpai_neg(a,b);   
}

void     inf_br_inv(inf_br_ref a,inf_br_const b)
{
  fprintf(stderr,"\n Inverse : ");
  inf_br_out(b,stderr);
  mpai_inv(a,b);   
}

void     inf_br_pow(inf_br_ref a,inf_br_const b,const RS_ULONG c)
{
  rs_undef_void("inf_br_gcd");
  /*  mpz_pow_ui(mpai_numref(a),mpai_numref(b),c);  
      mpz_pow_ui(mpai_denref(a),mpai_denref(b),c);  
  */
}

void     inf_br_gcd(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  rs_undef_void("inf_br_gcd");
}

void     inf_br_rem(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  rs_undef_void("inf_br_rem");
}

void     inf_br_lcm(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  rs_undef_void("inf_br_lcm");
}

RS_LONG  inf_br_mod(inf_br_const a,const RS_LONG b)
{
  rs_not_implemented_void("inf_br_mod");  
  return(0);
}

void     inf_br_dadd(inf_br_ref a,inf_br_const b)
{
  mpai_add(a,a,b);
}

void     inf_br_dsub(inf_br_ref a,inf_br_const b)
{
  mpai_sub(a,a,b);
}
void     inf_br_dmul(inf_br_ref a,inf_br_const b)
{
  mpai_mul(a,a,b);
}

void     inf_br_ddiv(inf_br_ref a,inf_br_const b)
{
  mpai_div(a,a,b);
}

void     inf_br_dexactdiv(inf_br_ref a,inf_br_const b)
{
  mpai_div(a,a,b);
}

void     inf_br_daddmul(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_t tmp;
  mpai_init(tmp);
  mpai_mul(tmp,b,c);
  mpai_add(a,a,tmp);
}

void     inf_br_dsubmul(inf_br_ref a,inf_br_const b,inf_br_const c)
{
  mpai_t tmp;
  mpai_init(tmp);
  mpai_mul(tmp,b,c);
  mpai_sub(a,a,tmp);   
}

void     inf_br_dcomb(inf_br_ref a,inf_br_const b,inf_br_const c,inf_br_const d)
{
  mpai_t tmp;
  mpai_init(tmp);
  mpai_mul(a,a,b);
  mpai_mul(tmp,c,d);
  mpai_add(a,a,tmp);
}

void     inf_br_dneg(inf_br_ref a)
{
  mpai_neg(a,a);
}

void     inf_br_dinv(inf_br_ref a)
{
  mpai_inv(a,a);   
}

void     inf_br_dpow(inf_br_ref a,const RS_ULONG b)
{
  rs_undef_void("inf_br_dpow");
  /*
  mpz_pow_ui(mpai_numref(a),mpai_numref(a),b);  
  mpz_pow_ui(mpai_denref(a),mpai_denref(a),b);  
  */
}

void     inf_br_dgcd(inf_br_ref a,inf_br_const b)
{
  rs_undef_void("inf_br_dgcd");
}

void     inf_br_drem(inf_br_ref a,inf_br_const b)
{
  rs_undef_void("inf_br_drem");
}

void     inf_br_dlcm(inf_br_ref a,inf_br_const b)
{
  rs_undef_void("inf_br_dlcm");
}

void     inf_br_in(inf_br_ref a,FILE * f)
{
  rs_undef_void("inf_br_in");

  /*
  int c;
  mpz_inp_str(mpai_numref(a),f,10);
  c=fgetc(f);
  if (RS_EQ(c,'/')) { 
    mpz_inp_str(mpai_denref(a),f,10);
  }
  else {
    fputc(c,f);
  }
  */
}

void     inf_br_out(inf_br_const a,FILE * f)
{
  mpai_mpq_out_str(f,a);
}

inf_br_rep *     inf_br_copy_rep(inf_br_const a)
{
  inf_br_rep * tmp = (inf_br_rep *) RSALLOC(sizeof(inf_br_rep));
  mpai_init(tmp);
  mpai_set(tmp,a);
  return(tmp);
}
inf_br *     inf_br_copy(inf_br_const a)
{
  inf_br * tmp = (inf_br *) RSALLOC(sizeof(inf_br));
  mpai_init(*tmp);
  mpai_set(*tmp,a);
  return(tmp);
}

 RS_BOOL HAS_RING_inf_br() 
{
return(1);
}

 RS_BOOL HAS_FIELD_inf_br() 
{
return(1);
}

 RS_BOOL HAS_EUCLI_inf_br() 
{
return(0);
}

 RS_BOOL HAS_ORDER_inf_br() 
{
return(1);
}

 RS_BOOL HAS_FLOAT_inf_br() 
{
return(0);
}

 RS_BOOL HAS_EXACT_DIV_inf_br() 
{
return(1);
}

 RS_BOOL HAS_GCD_inf_br() 
{
return(0);
}

 RS_BOOL HAS_MODP_inf_br() 
{
return(1);
}

 RS_BOOL HAS_CHINEESE_inf_br() 
{
return(1);
}

 RS_BOOL COERCIBLE_TO_LONG_inf_br() 
{
return(0);
}

 RS_BOOL COERCIBLE_TO_DOUBLE_inf_br() 
{
return(0);
}

 RS_BOOL NEED_GC_inf_br() 
{
return(0);
}

void inf_br_set_root(inf_br_ref c)
{ 
#ifdef USE_RSGC

#endif
}

void        inf_br_mul_2exp(inf_br_ref a,inf_br_const b,const RS_ULONG c)
{
  /*
  inf_br_init_c(a,b);
  mpz_mul_2exp(mpai_numref(a),mpai_numref(b),c);
  */
}

void        inf_br_mul_ui(inf_br_ref a,inf_br_const b,const RS_ULONG c)
{
  /*
  inf_br_init_c(a,b);
  mpz_mul_ui(mpai_numref(a),mpai_numref(b),c);
  */
}
 
void        inf_br_dmul_2exp(inf_br_ref a,const RS_ULONG c)
{
  /*
  mpz_mul_2exp(mpai_numref(a),mpai_numref(a),c);
  */
}

RS_BOOL inf_br_read_buff(rs_buff_in_ref b,inf_br_ref z)
{
  /*
  inf_br_init(z);
  if(bz_read_buff(b,mpai_numref(z))){ 
    if (read_sep_in_buff(b,'/')){
      if(bz_read_buff(b,mpai_denref(z))){
	return(RS_TRUE);
      }
      else return(RS_FALSE);
    }
    else {
      bz_init_i(mpai_denref(z),1); 
      return(RS_TRUE);
    }
  }
  else  return(RS_FALSE);
  */
}

